plus(X,Y,Z) :- makelist(X,L1),
               makelist(Y,L2),
               count(L1,C1),
               count(L2,C2),
               C is C1 + C2,
               construct(C,Z1),
               Z =.. Z1.

count(L,C) :- C1 is 0,cnt(L,C1,C).

cnt([],C,C).
cnt([s|Y],C1,C) :- C2 is C1 + 1, cnt(Y,C2,C).

construct(C,[s,0]) :- C < 1,!.
construct(C,L) :- C1 is C - 1, con(C1,X), L = [s,X].
con(C,0) :- C < 1,!.
con(C,X) :- C1 is C - 1, con(C1,Y), X = s(Y).

makelist(X,L) :- L1 = [],ml(X,L1,L).
ml(0,L,L).
ml(X,L1,L) :- X =.. [A,B],append([A],L1,L2),ml(B,L2,L).

append([],L,L).
append([X|L1],L2,[X|L3]) :- append(L1,L2,L3).
mult(X,Y,Z) :- makelist(X,L1),
               makelist(Y,L2),
               count(L1,C1),
               count(L2,C2),
               C is C1 * C2,
               construct(C,Z1),
               Z =.. Z1.

lessthan(X,Y) :- makelist(X,L1),
                 makelist(Y,L2),
                 count(L1,C1),
                 count(L2,C2),
                 C1 < C2.

minus(X,Y,Z) :- makelist(X,L1),
                makelist(Y,L2),
                count(L1,C1),
                count(L2,C2),
                C1 >= C2,
                !, C is C1 - C2,
                construct(C,Z1),
                Z =.. Z1.
minus(X,Y,Z) :- Z = s(0).

intdiv(X,Y,Z) :- makelist(X,L1),
                 makelist(Y,L2),
                 count(L1,C1),
                 count(L2,C2),
                 C is C1 / C2,
                 construct(C,Z1),
                 Z =.. Z1.

squareroot(X,Z) :- makelist(X,L),
                   count(L,C),
                   C1 is sqrt(C),
                   construct(C1,Z1),
                   Z =.. Z1.
