concord(S,C) :- C1 = [], con(S,C1,C).

con([],C,C).
con(S,C1,C)
  :- W1 = [],
     getaword(S,W1,W,S1),
     name(W2,W),
     C3 = [],
     update(C1,W2,C3,C2),
     con(S1,C2,C).
 
getaword([],W,W,[]).
getaword([X|Y],W,W,Y) :- (X = 32;X = 46),!.
getaword([X|Y],W1,W,S1) :- append(W1,[X],W2),getaword(Y,W2,W,S1).

append([],L,L).
append([X|L1],L2,[X|L3]) :- append(L1,L2,L3).

update([],W1,C3,C2) :- append(C3,[[W1,1]],C2).
update([[W1,X]|Y],W2,C3,C2)
  :- lessthan(W1,W2),!,
     append(C3,[[W1,X]],C4),
     update(Y,W2,C4,C2).
update([[W1,X]|Y],W1,C3,C2)
  :- X1 is X + 1,
     append(C3,[[W1,X1]],C4),
     update1(Y,W1,C4,C2).
update([[W1,X]|Y],W2,C3,C2)
  :- append(C3,[[W2,1]],C4),
     append(C4,[[W1,X]],C5),
     update1(Y,W2,C5,C2).

update1([],W,C,C).
update1([X|Y],W,C3,C2) :- append(C3,[X],C4),update1(Y,W,C4,C2).

lessthan(W1,W2) :- name(W1,L1),name(W2,L2),lt(L1,L2).
lt([],Y) :- Y \== [].
lt([X1|Y1],[X2|Y2]) :- X1 < X2,!.
lt([X1|Y1],[X1|Y2]) :- lt(Y1,Y2).
