
member(X, [X|R]).
member(X, [Y|R]) :- member(X, R).

sublist(S, L) :- append(S, S2, L).
sublist(S, [H|T]) :- sublist(S, T).

append([], L, L).
append([X|R], Y, [X|T]) :- append(R, Y, T).

evenlength([]) :- !.
evenlength([X,Y|Z]) :- evenlength(Z).

oddlength([X|Y]) :- Y = [], !.
oddlength([X,Y|Z]) :- oddlength(Z).

reverse([],[]).
reverse([X|Y],L) :- reverse(Y,L1), append(L1,[X],L).

palindrome(L) :- reverse(L,L1), L1 = L.

rotateleft([X|Y],L) :- append(Y,[X],L).

means(0,zero).
means(1,one).
means(2,two).
means(3,three).
means(4,four).
means(5,five).
means(6,six).
means(7,seven).
means(8,eight).
means(9,nine).

translate([],[]).
translate([X|Y],[U|V]) :- means(X,U), translate(Y,V).

