
queens(N) :- inlist(N,[],L),
             solve([],Sol,L,L),
             printboard(N,Sol).

inlist(1,L,[1|L]).
inlist(X,L1,L2) :- X > 1, Y is X - 1, inlist(Y,[X|L1],L2).

solve(Input,Output,[Row|R],Columns)
  :- choose(Col,Columns,C),
     Up is Row - Col,
     Down is Row + Col,
     safe(Up,Down,Input),
     solve([square(Col,Up,Down)|Input],Output,R,C).
solve(L,L,[],[]).

choose(X,[X|Y],Y).
choose(X,[H|T1],[H|T2]) :- choose(X,T1,T2).

safe(U1,D1,[square(_,U,D)|Rest])
  :- U1 \== U,
     D1 \== D,
     safe(U1,D1,Rest).
safe(_,_,[]).

printboard(N,[square(X,_,_)|L])
  :- nl,
     Y is X - 1,
     writedots(Y),
     print('Q'),
     W is N - X,
     writedots(W),
     printboard(N,L).
printboard(N,[]) :- nl.

writedots(X) :- X > 0,
                print('.'),
                Y is X - 1,
                writedots(Y).
writedots(0).
